Summary: The Linux kernel (the core of the Linux operating system). DEVELOPMENT VERSION
Name: hackkernel
%define srcversion 2.3.99-pre5
%define kversion 2.3.99-pre6
%define release 1.2mdk
Version: 2.3.99pre6
Release: %{release}
%define KVERREL %{PACKAGE_VERSION}-%{PACKAGE_RELEASE}
Copyright: GPL
Group: System/Kernel and hardware
ExclusiveArch: i386 i486 i586 i686 k6 k7
ExclusiveOS: Linux

#
# Sources
#
Source0: ftp://ftp.kernel.org/pub/linux/kernel/v2.3/linux-%{srcversion}.tar.bz2

Source11: module-info
Source12: installkernel
Source13: rhkmvtag.c
Source15: linux_logo.h.bz2

Source20: kernel-%{kversion}-i386.config

#
# Patches
#
Patch0: pre6-3.bz2

Patch10: supermount-0.3.1-2.3.99-pre5.diff.bz2

Patch11: acpi-2.3.99.6.3.patch.bz2
Patch12: credit-2.3.99.6.3.patch.bz2
Patch13: mount-fix-2.3.99.6.3.patch.bz2
Patch14: ne2k-pci-fix-2.3.99.6.3.patch.bz2
Patch15: pci1-2.3.99.6.3.patch.bz2
Patch16: pci2-2.3.99.6.3.patch.bz2
Patch17: ide-cd-supermount.patch.bz2
Patch18: devfs-nomount-2.3.99.6.3.patch.bz2
Patch19: 2.3.99pre6-3-APM.1.bz2
#Patch20: module-compile-2.3.99.3.patch.bz2
Patch21: fucking.patch.bz2
Patch22: fasync-fail-return.patch.bz2


BuildRoot: %{_tmppath}/%{name}-%{version}-build
Autoreqprov: no
Requires: initscripts >= 3.64

%package source
Requires: hackkernel-headers = %{kversion}-%{release}
Summary: The source code for the Linux kernel. DEVELOPMENT VERSION
Conflicts: kernel-source
Group: Development/Kernel

%package headers
Summary: Header files for the Linux kernel. DEVELOPMENT VERSION
Conflicts: kernel-headers
Group: Development/Kernel

%package doc
Summary: Various documentation bits found in the kernel source. DEVELOPMENT VERSION
Group: Development/Kernel

%description
The kernel package contains the Linux kernel (vmlinuz), the core of your
Linux operating system.  The kernel handles the basic functions of the
operating system:  memory allocation, process allocation, device
input and output, etc.

WARNING: This is the CURRENT DEVELOPMENT VERSION of the Linux kernel. It has
more hardware support (USB, etc.) and is probably faster than the normal
kernel, but it is NOT STABLE. In the worst case, it can damage your
installation, or even your hardware. [Experience shows that even development
versions are usually more stable than Windoze NT though ;) ]

If you don't know what you're doing, you should use this package only if you
depend on the new features.


%description source
The kernel-source package contains the source code files for the Linux
kernel. These source files are needed to build most C programs, since
they depend on the constants defined in the source code. The source
files can also be used to build a custom kernel that is better tuned to
your particular hardware, if you are so inclined (and you know what you're
doing).

WARNING: This is the CURRENT DEVELOPMENT VERSION of the Linux kernel. It has
more hardware support (USB, etc.) and is probably faster than the normal
kernel, but it is NOT STABLE. In the worst case, it can damage your
installation, or even your hardware. [Experience shows that even development
versions are usually more stable than Windoze NT though ;) ]

If you don't know what you're doing, you should use this package only if you
depend on the new features.

%description headers
Kernel-headers includes the C header files for the Linux kernel.  The
header files define structures and constants that are needed for building
most standard programs.  The header files are also needed for rebuilding
the kernel.

WARNING: This is the CURRENT DEVELOPMENT VERSION of the Linux kernel. It has
more hardware support (USB, etc.) and is probably faster than the normal
kernel, but it is NOT STABLE. In the worst case, it can damage your
installation, or even your hardware. [Experience shows that even development
versions are usually more stable than Windoze NT though ;) ]

If you don't know what you're doing, you should use this package only if you
depend on the new features.

%description doc
This package contains documentation files form the kernel source. Various
bits of information about the Linux kernel and the device drivers shipped
with it are documented in these files. You also might want install this
package if you need a reference to the options that can be passed to Linux
kernel modules at load time.

WARNING: This is the CURRENT DEVELOPMENT VERSION of the Linux kernel. It has
more hardware support (USB, etc.) and is probably faster than the normal
kernel, but it is NOT STABLE. In the worst case, it can damage your
installation, or even your hardware. [Experience shows that even development
versions are usually more stable than Windoze NT though ;) ]

If you don't know what you're doing, you should use this package only if you
depend on the new features.

%prep
%setup -q -n linux

# push in Mandrake bootlogo
cp %SOURCE15 include/linux/linux_logo.h.bz2
bzip2 -fd include/linux/linux_logo.h.bz2

# kernel patches
%patch0 -p1
#%patch1 -p1
#%patch2 -p1
#%patch3 -p1
#%patch4 -p1
#%patch5 -p1
#%patch6 -p1
#%patch7 -p1
#%patch8 -p1
#%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
#%patch20 -p0
%patch21 -p1
%patch22 -p1

# Bring in the Red Hat Kernel Module Version Tag program
cp $RPM_SOURCE_DIR/rhkmvtag.c .

###
### build
###

%build

if [ -x /usr/bin/getconf ] ; then
    NRPROC=$(/usr/bin/getconf _NPROCESSORS_ONLN)
    if [ $NRPROC -eq 0 ] ; then
    NRPROC=1
    fi
else
    NRPROC=1
fi

BuildKernel() {
    # is this a special kernel we want to build?
	Config=$RPM_ARCH
	KernelVer=%{version}-%{release}
	echo BUILDING THE NORMAL KERNEL...
    cp %SOURCE20 arch/i386/defconfig

    # make sure EXTRAVERSION says what we want it to say
    perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}$1/" Makefile
    perl -p -i -e "s/-m386//" arch/i386/Makefile
    perl -p -i -e "s/-m486//" arch/i386/Makefile
    rm -f .config
    make mrproper
    ln -s arch/i386/defconfig .config

    export CFLAGS="$RPM_OPT_FLAGS"
    export CXXFLAGS="$RPM_OPT_FLAGS"
    make oldconfig
	
	cp -f .config $RPM_SOURCE_DIR/kernel-%{kversion}-$Config.config

    make dep 
    make include/linux/version.h 
    make bzImage
    make modules
    mkdir -p $RPM_BUILD_ROOT/boot
    install -m 644 System.map $RPM_BUILD_ROOT/boot/System.map-$KernelVer
    cp arch/i386/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-$KernelVer
    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/{block,cdrom,fs,ipv4,misc,net,scsi,video}
    make INSTALL_MOD_PATH=$RPM_BUILD_ROOT modules_install KERNELRELEASE=$KernelVer
    #Identify the modules directory with the Red Hat Kernel Module Version Tag
    cc -o rhkmvtag rhkmvtag.c init/version.o
    ./rhkmvtag > $RPM_BUILD_ROOT/lib/modules/$KernelVer/.rhkmvtag
    rm -f rhkmvtag
}

###
# DO it...
###

rm -rf $RPM_BUILD_ROOT

# NORMAL KERNEL
BuildKernel

###
### install
###

%install

# Install config files.
mkdir -p Documentation/config/
for i in $RPM_SOURCE_DIR/*$RPM_ARCH*config;do
    install -m644 $i Documentation/config/
done


mkdir -p $RPM_BUILD_ROOT/usr/include
ln -sf ../src/linux/include/linux $RPM_BUILD_ROOT/usr/include/linux
ln -sf ../src/linux/include/asm $RPM_BUILD_ROOT/usr/include/asm

mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{kversion} 

mkdir -p $RPM_BUILD_ROOT/{boot,sbin}
install -m 755 $RPM_SOURCE_DIR/installkernel $RPM_BUILD_ROOT/sbin/installkernel
install -m 644 $RPM_SOURCE_DIR/module-info $RPM_BUILD_ROOT/boot/module-info-%{KVERREL}

mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
tar --exclude '*.o' --exclude '*.a' -cf - . | ( cd $RPM_BUILD_ROOT/usr/src/linux-%{kversion} ; tar xvfp - )
ln -sf linux-%{kversion} $RPM_BUILD_ROOT/usr/src/linux
# make sure EXTRAVERSION says what we want it to say (in source)
perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}/" $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/Makefile
# use the standard i386 config in source
cp %SOURCE20 $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/.config
cp %SOURCE20 $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/arch/i386/defconfig


#clean up the destination

# ack to evit an annoying "environnment is too large for exec"

find . -name '*.[oas]' -type f -print | grep -v lxdialog/ | xargs rm -f

perl -p -i -e "s/find \. -name '\*\.\[oas\]' -type f -print | grep -v lxdialog\/ | xargs rm -f/# find . -name '*.[oas]' -type f -print | grep -v lxdialog\/ | xargs rm -f/" $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/Makefile

make mrproper -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}

perl -p -i -e "s/# find \. -name '\*\.\[oas\]' -type f -print | grep -v lxdialog\/ | xargs rm -fr/find . -name '*.[oas]' -type f -print | grep -v lxdialog\/ | xargs rm -f/" $RPM_BUILD_ROOT/usr/src/linux-%{kversion}/Makefile


make oldconfig -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
make symlinks -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
make include/linux/version.h -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}

#this generates modversions info which we want to include and we may as
#well include the depends stuff as well, after we fix the paths
make depend -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
find $RPM_BUILD_ROOT/usr/src/linux-%{kversion} -name ".*depend" | \
while read file ; do
    mv $file $file.old
    sed -e "s|[^ ]*\(/usr/src/linux\)|\1|g" < $file.old > $file
    rm -f $file.old
done

###
### clean
###

%clean
# rm -rf $RPM_BUILD_ROOT

###
### scripts
###

# do this for upgrades...in case the old modules get removed we have
# loopback in the kernel so that mkinitrd will work.
%pre
/sbin/modprobe loop 2> /dev/null > /dev/null
exit 0

%post
cd /boot
ln -sf vmlinuz-%{KVERREL} vmlinuz
ln -sf System.map-%{KVERREL}  System.map
ln -sf module-info-%{KVERREL}  module-info

%ifarch i386 i486 i586 i686 k6 k7
if [ -x /usr/sbin/detectloader ];then
LOADER=$(/usr/sbin/detectloader)
	if [ "$LOADER" = "LILO" ];then          
		if [ -x /sbin/lilo -a -f /etc/lilo.conf ]; then
			/sbin/lilo > /dev/null 2>&1
			exit 0
		fi
	fi
fi
%endif

%post headers
cd /usr/src
rm -f linux
ln -snf linux-%{kversion} linux

%post source
cd /usr/src
rm -f linux
ln -snf linux-%{kversion} linux

%postun headers
if [ -L /usr/src/linux ]; then 
    if [ `ls -l /usr/src/linux | awk '{ print $11 }'` = "linux-%{kversion}" ]; then
	[ $1 = 0 ] && rm -f /usr/src/linux
    fi
fi
exit 0

%postun source
if [ -L /usr/src/linux ]; then 
    if [ `ls -l /usr/src/linux | awk '{ print $11 }'` = "linux-%{kversion}" ]; then
	[ $1 = 0 ] && rm -f /usr/src/linux
    fi
fi
exit 0

###
### file lists
###

%files 
%defattr(-,root,root)
/boot/vmlinuz-%{KVERREL}
/boot/System.map-%{KVERREL}
/boot/module-info-%{KVERREL}
%dir /lib/modules
/lib/modules/%{KVERREL}

%files source
%defattr(-,root,root)
%dir /usr/src/linux-%{kversion}
/usr/src/linux-%{kversion}/COPYING
/usr/src/linux-%{kversion}/CREDITS
/usr/src/linux-%{kversion}/Documentation
/usr/src/linux-%{kversion}/MAINTAINERS
/usr/src/linux-%{kversion}/Makefile
/usr/src/linux-%{kversion}/README
/usr/src/linux-%{kversion}/REPORTING-BUGS
/usr/src/linux-%{kversion}/Rules.make
/usr/src/linux-%{kversion}/drivers
/usr/src/linux-%{kversion}/fs
/usr/src/linux-%{kversion}/init
/usr/src/linux-%{kversion}/ipc
/usr/src/linux-%{kversion}/kernel
/usr/src/linux-%{kversion}/lib
/usr/src/linux-%{kversion}/mm
/usr/src/linux-%{kversion}/net
/usr/src/linux-%{kversion}/scripts
/usr/src/linux-%{kversion}/arch/i386

%files headers
%defattr(-,root,root)
%dir /usr/src/linux-%{kversion}
/usr/src/linux-%{kversion}/include/asm
/usr/src/linux-%{kversion}/include/asm-i386
/usr/src/linux-%{kversion}/include/asm-generic
/usr/src/linux-%{kversion}/include/linux
/usr/src/linux-%{kversion}/include/net
/usr/src/linux-%{kversion}/include/scsi
/usr/src/linux-%{kversion}/include/video
/usr/include/asm
/usr/include/linux

%files doc
%defattr(-,root,root)
%doc Documentation/*

%changelog
* Wed Apr 19 2000 Jeff Garzik <jgarzik@mandrakesoft.com> 2.3.99pre6-1.2mdk
- re-upload to contribs
- add devfs=nomount as default
- update BuildRoot
- support for non-LILO boot loaders (chmou)
- APM update (Stephen Rothwell, APM maintainer)
- fasync fix (Rusty Russell)
- module_init/exit warning fix (Rusty Russell)

* Tue Apr 18 2000 Jeff Garzik <jgarzik@mandrakesoft.com> 2.3.99pre6-1.1mdk
- 2.3.99-pre6-pre3
- add supermount patch (hi Gael :))
- mount(2), ACPI, PCI, ne2tk-pci bug fixes

* Wed Apr 12 2000 Jeff Garzik <jgarzik@mandrakesoft.com> 2.3.99pre6-1.0mdk
- 2.3.99-pre6-pre1

* Tue Apr 11 2000 Jeff Garzik <jgarzik@mandrakesoft.com> 2.3.99pre5-1.1mdk
- 2.3.99-pre5 release
- fix source package such that it does not equal headers package
- updated groups
- remove '_config' prefix from installkernel script
- afirda fix from Garst Reese
- umsdos fix from 'ac' patch
- comx obsolete patch to disable comx build
- ac sound patch, including new i810_audio and Ali audio drivers

* Mon Apr 03 2000 Jeff Garzik <jgarzik@mandrakesoft.com> 2.3.99pre4-1.0mdk
- 2.3.99-pre4-pre3 (includes several bugfixes, among other things)

* Fri Mar 24 2000 Jeff Garzik <jgarzik@mandrakesoft.com> 2.3.99pre3-1.1mdk
- 2.3.99-pre3 final

* Fri Mar 24 2000 Jeff Garzik <jgarzik@mandrakesoft.com> 2.3.99pre3-1.0mdk
- 2.3.99-pre3-pre8

* Sun Feb 6 2000 Jeff Garzik <jgarzik@mandrakesoft.com> 2.3.42-1.0mdk
- 2.3.42
- New release numbering scheme

* Fri Jan 28 2000 Jeff Garzik <jgarzik@mandrakesoft.com> 2.3.41-2mdk
- 2.3.41-pre4

* Fri Jan 21 2000 Jeff Garzik <jgarzik@mandrakesoft.com>
- 2.3.40 official

* Wed Jan 12 2000 Jeff Garzik <jgarzik@mandrakesoft.com>
- 2.3.40-pre1

* Tue Jan 11 2000 Jeff Garzik <jgarzik@mandrakesoft.com>
- 2.3.39
- USB fixes

* Sun Jan 9 2000 Jeff Garzik <jgarzik@mandrakesoft.com>
- 2.3.39-pre1
- CD stuff from Jens Axboe
- Little fixes from Tim Waugh

* Sat Jan 8 2000 Jeff Garzik <jgarzik@mandrakesoft.com>
- 2.3.38
- PCI fixes from Martin Mares
- TCQ fix from David Miller

* Fri Jan 7 2000 Jeff Garzik <jgarzik@mandrakesoft.com>
- 2.3.38-pre1

* Thu Jan 6 2000 Jeff Garzik <jgarzik@mandrakesoft.com>
- 2.3.36

* Wed Dec 29 1999 Florent Villard <warly@mandrakesoft.com> 2.3.35-6mdk
- remove riva frame buffer

* Wed Dec 29 1999 Florent Villard <warly@mandrakesoft.com> 2.3.35-5mdk
- 2.3.35
- usb hid 

* Tue Dec 28 1999 Florent Villard <warly@mandrakesoft.com>
- 2.3.35pre6

* Fri Dec 24 1999 Florent Villard <warly@mandrakesoft.com>
- 2.3.35pre3
- initrd patch

* Wed Dec 22 1999 Florent Villard <warly@mandrakesoft.com>
- 2.3.35pre1

* Tue Dec 21 1999 Florent Villard <warly@mandrakesoft.com>
- 2.3.34

* Fri Dec 17 1999 Florent Villard <warly@mandrakesoft.com>
- 2.3.34pre1

* Thu Dec 9 1999 Florent Villard <warly@mandrakesoft.com>
- 2.3.32pre2

* Thu Dec 2 1999 Florent Villard <warly@mandrakesoft.com>
- 2.3.30pre3

* Mon Nov 29 1999 Florent Villard <warly@mandrakesoft.com>
- 2.3.29 
- ramdisk and initrd fix

* Thu Oct 14 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Various compilation fixes.
- Remove BOOT kernel from 2.3.
- Add nfsv3 patchs.
- 2.3.21.

* Tue Sep 28 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- 2.3.18ac10

* Wed Sep 22 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- 2.3.18ac8

* Tue Sep 21 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- 2.3.18ac7

* Thu Sep 15 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- 2.3.18ac5
- fix compilation of ATM_AMBASSADOR and RTRACK2 modules in SMP
- re-enable building EVERYTHING ! Yes, it finally works!!!!! :)))
- package atm and usb modules
- package pcmcia modules for SMP builds

* Tue Sep 13 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- 2.3.18ac3
- remove pcmcia-cs (now supported by standard kernel)

* Wed Sep 1 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- 2.3.16
- add lspnp and setpnp tools to pcmcia-cs (included with pcmcia-cs 3.1)
- fix compilation
- fix compilation of HPT366 and STALLION drivers
- re-enable building various drivers
- pcmcia 31-Aug-99
H
- disable CONFIG_R3964, CONFIG_I2O_PCI

* Tue Aug 31 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- 2.3.16-pre1

* Thu Aug 26 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- 2.3.15-final
- fix compilation of the CompuTone IP2 driver (CONFIG_COMPUTONE)
- re-enable CONFIG_COMPUTONE, CONFIG_USB_ACM, CONFIG_IBMOL

* Tue Aug 24 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- 2.3.15-pre3
- pcmcia 23-Aug-99
- deactivate CONFIG_BLK_DEV_AEC6210, CONFIG_BLK_DEV_HPT34X,
  CONFIG_BLK_DEV_HPT366, CONFIG_BLK_DEV_PDC202XX,
  CONFIG_COMPUTONE, CONFIG_USB_ACM, CONFIG_ATM_ENI, CONFIG_ATM_ZATM,
  CONFIG_ATM_NICSTAR, CONFIG_ATM_HORIZON
- reactivate CONFIG_IBMOL
- adapt .config files

* Mon Aug 23 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- fix compilation of ISA PNP modules
- some adaptions for PCMCIA 3.1
- fix compilation of PCMCIA 3.1 with gcc 2.95

* Sun Aug 22 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- 2 3.15-pre2

* Thu Aug 19 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- 2.3.14

* Sat Aug 14 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- 2.3.14pre1
- re-enable NCR53C8XX, EICON-ISDN, AVMB1-ISDN, TELES PCI, FRITZ PCI support
  (fixed)
- pcmcia 11-Aug

* Mon Aug 9 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- 2.3.13
- fix compilation with {p,}gcc 2.95
- fix compilation of raid and md drivers
- disable broken drivers for now:
  SPECIALIX, IBMOL, NCR53C8XX, TELESPCI, FRITZPCI, AVM B1, EICON
- PCMCIA 10-Aug-99
- re-enable UMSDOS

* Mon Aug 2 1999 Bernhard Rosenkraenzer <bero@mandrakesoft.com>
- 2.3.13 pre1
- PCMCIA 22-Jul
- fix compilation of EATA drivers
- fix PCMCIA compilation
- re-enable loop and minixfs drivers (finally got fixed)

- fix dependancy bugs (hackkernel-source requires hackkernel-headers, not
  kernel-headers), conflict hackkernel-source<->kernel-source
- remove smptcp patch (it's not required with 2.3.x)

* Mon Jul 13 1999 Bernhard Rosenkrnzer <bero@mandrakesoft.com>
- initial RPM based on 2.2.10-35mdk
- disable some devices that don't compile for now: loop, istallion, imm,
  minixfs, umsdosfs
- remove iBCS, there's no version for 2.3 yet (does anyone need it anyway?)
- fix compilation of pcmcia-cs
